Bug 1670256 (CVE-2019-3823) - CVE-2019-3823 curl: SMTP end-of-response out-of-bounds read
Summary: CVE-2019-3823 curl: SMTP end-of-response out-of-bounds read
Status: NEW
Alias: CVE-2019-3823
Product: Security Response
Classification: Other
Component: vulnerability   
(Show other bugs)
Version: unspecified
Hardware: All Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=low,public=20190206,reported=2...
Keywords: Security
Depends On: 1674362 1674363 1672906
Blocks: 1670258
TreeView+ depends on / blocked
 
Reported: 2019-01-29 04:29 UTC by Sam Fowler
Modified: 2019-02-18 14:28 UTC (History)
37 users (show)

Fixed In Version: curl 7.64.0
Doc Type: If docs needed, set a value
Doc Text:
An out-of-bounds read flaw was found in the way curl handled certain SMTP responses. A remote attacker could use this flaw to crash curl.
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

Description Sam Fowler 2019-01-29 04:29:19 UTC
libcurl versions from 7.34.0 to before 7.64.0 are vulnerable to a heap out-of-bounds read in the code handling the end-of-response for SMTP.

If the buffer passed to `smtp_endofresp()` isn't NUL terminated and contains no character ending the parsed number, and `len` is set to 5, then the `strtol()` call reads beyond the allocated buffer. The read contents will not be returned to the caller.


Bug introduced by:

https://github.com/curl/curl/commit/2766262a68

Comment 1 Sam Fowler 2019-01-29 04:29:20 UTC
Acknowledgments:

Name: Daniel Stenberg (the Curl project)
Upstream: Brian Carpenter (Geeknik Labs)

Comment 2 Sam Fowler 2019-02-06 07:50:34 UTC
External Reference:

https://curl.haxx.se/docs/CVE-2019-3823.html


Upstream Patch:

https://github.com/curl/curl/commit/39df4073

Comment 3 Sam Fowler 2019-02-06 07:50:47 UTC
Created curl tracking bugs for this issue:

Affects: fedora-all [bug 1672906]

Comment 4 Huzaifa S. Sidhpurwala 2019-02-11 06:37:16 UTC
Mitigation:

Do not use SMTP authentication with curl


Note You need to log in before you can comment on or make changes to this bug.